package MainLibrary;

import java.util.*;

public abstract class LigandObserver {

	public String ID=null;

	public List<NanoObj> ligandList=new ArrayList<NanoObj>();

	public synchronized void obsLigand(CarrierObj c){
		if(c!=null){			
			if (!(ligandList.contains(c))) ligandList.add(c);
		}else{
			System.out.println(" == ERROR IN LigandObserver: Carrier is NULL!!!");
		}
	}
	
	public synchronized void removeLigand(CarrierObj c){
		ligandList.remove(c);
	}
}
