package MainLibrary;

import java.util.ArrayList;
import java.util.List;

public class MergeSorter {

	// MERGE SORT
	private static void mergeSort(List<NanoCollision> a, List<NanoCollision> vectorTemp, int left, int right) {
		if (left < right) {
			int center = (left + right) /2;
			mergeSort (a, vectorTemp, left, center);
			mergeSort (a, vectorTemp, center+1, right);
			merge (a, vectorTemp, left, center+1, right);
		}
	}

	public static void mergeSort(List<NanoCollision> a) {
		List<NanoCollision> vectorTemp=new ArrayList<NanoCollision>();
		mergeSort (a, vectorTemp, 0, a.size()-1);
	}

	private static void merge(List<NanoCollision> a, List<NanoCollision> vectorAux, int posLeft, int posRight, int posEnd) {
		int endLeft = posRight -1;
		int posAux = posLeft;
		int numElemen = posEnd - posLeft +1;

		while (posLeft <= endLeft && posRight <=posEnd) {
			if ((a.get(posLeft).getDt())< (a.get(posRight).getDt()))
				vectorAux.add(posAux++,a.get(posLeft++));
			else
				vectorAux.add(posAux++, a.get(posRight++));		
		}

		while (posLeft <= endLeft)
			vectorAux.add(posAux++,a.get(posLeft++));

		while (posRight <= posEnd)
			vectorAux.add(posAux++,a.get(posRight++));

		for (int i=0;i<numElemen;i++,posEnd--)
			a.set(posEnd,vectorAux.get(posEnd));
	}
}
