package MainLibrary;

public class NanoCollision extends AbstractCollision{

	public NanoObj p1,p2;
	
	public NanoCollision(NanoObj p1, NanoObj p2, double dt){
		this.p1=p1;
		this.p2=p2;
		this.setDt(dt);	
	}	

	public NanoCollision(NanoObj p1, double dt){
		InnerSphericalDomain sDomain=(InnerSphericalDomain)p1.getDomain();
		this.p1=p1;
		this.p2=sDomain.getOwner();
		this.setDt(dt);			
	}	

	public void handleCollision(){	

		/** FIXME 
		 *  Controllo aggiunto per risolvere la NullPointerException dovuta a NanoObj con dominio==null
		 *  Probabilmente il null viene impostato dai recettori che stanno avviando il download delle carrier,
		 *  quindi non ha senso andare a gestire collisioni multiple di tali carrier con altri nanoobjs!
		 *  Se RISOLVE, andr messo anche negli altri tipi di Collision! (con il dominio esterno e interno...)
		 */
		if(p1.getDomain()!=null && p2.getDomain()!=null)	p1.estabilishContact(p2);
	}	
}