package MainLibrary;

public class rDownloading extends ReceptorState {

	private int type;	
	
	public rDownloading(UniversalReceptor r) {
		super(r);
		setFree(false);		
		type=r.getReceptorType();
		setProcessingTime(getTiming());	
		r.eventHandler.addActiveReceptor(r);
	}

	public int getTiming(){			
		return getReceptor().getOuterDomain().getManager().configWrapper.receptorStateConfig.get(type+"-downloadTime").intValue();
	}

	public void performAction() {
		if (getReceptor().getCurrentCarrier()!=null){					
			if (remainingTime>0){
				remainingTime--;
			}else{				
				getReceptor().download();			
			}
		}else{
			getReceptor().setInternalState(new rActive(getReceptor()));
		}
	}
}