package MainLibrary;

import java.util.Random;

public class rRandomDownloading extends ReceptorState {

	private int type;	
	
	public rRandomDownloading(UniversalReceptor r) {
		super(r);
		setFree(false);		
		type=r.getReceptorType();
		setProcessingTime(getTiming());	
		r.eventHandler.addActiveReceptor(r);
	}

	public int getTiming(){	
		Random rand=new Random();
		
		int fixedTime=getReceptor().getOuterDomain().getManager().configWrapper.receptorStateConfig.get(type+"-downloadTime").intValue();
		int randomTime=(int) (-fixedTime*Math.log(1-rand.nextFloat()));
		
		return randomTime;
	}

	public void performAction() {
		if (getReceptor().getCurrentCarrier()!=null){					
			if (remainingTime>0){
				remainingTime--;
			}else{				
				getReceptor().download();			
			}
		}else{
			getReceptor().setInternalState(new rActive(getReceptor()));
		}
	}
}