package Octree;

import java.util.ArrayList;
import java.util.concurrent.CountDownLatch;
import MainLibrary.NanoObj;


public class Thread_FillUp extends Thread{	
	
	public OctreeNode node;
	private CountDownLatch latch;
	private ArrayList<NanoObj> nanoList=new ArrayList<NanoObj>();
	
	public Thread_FillUp(OctreeNode octreeNode, CountDownLatch latch) {
		this.node=octreeNode;
		this.latch=latch;
	}

	public void run() {		

		nanoList=node.getAllNanoObjs();
		
		//if(nanoList.size()>=node.maxObjects){		// OLD
		if(node.hasToSplit()){		// NEW
			// fillup root tree
			for(NanoObj n:nanoList){
				n.attachOnNodeTree(node);		
			}
		}
		latch.countDown();	
	}
}
