package Octree;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.concurrent.CountDownLatch;


public class Thread_ParallelFillUp2 extends Thread{	
	
	public Octree node;
	private CountDownLatch latch;
	boolean done=false;
	
		
		
	public Thread_ParallelFillUp2(Octree octreeNode, CountDownLatch latch) {
		this.node=octreeNode;
		this.latch=latch;	
	}	
	
	public void run() {	

		done=false;
		
		if(node.getChildList().size()>0){
			
			//RELOCATE TO LEAFS!
			node.relocateAllToLeafs();
			
		}else if(node.hasToSplit()){		
			//SPLIT!

			node.createChilds();
			node.relocateAllToLeafs();
			//}

			ArrayList<Octree> leafs=node.getLeafs(node);

			ArrayList<Octree> temp=new ArrayList<Octree>();

			while(!done){
				
				for(Octree oo : leafs){
					
					if(oo.hasToSplit()){		
						//SPLIT!
						oo.createChilds();
						oo.relocateAllToLeafs();

						temp.addAll(oo.getLeafs(oo));
					}
				}

				if(temp.size()>0){
					done=false;
					leafs=new ArrayList<Octree>();
					leafs.addAll(temp);
					temp=new ArrayList<Octree>();
				}else{
					done=true;
				}
			}
		}		
		latch.countDown();	
	}	
	
	public void OLDrun() {		
		//HashSet<Octree> leafOverfilled=new HashSet<Octree>();			
		node.createChilds();		
		latch.countDown();	
	}
}
