package Octree;


import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.CountDownLatch;

import MainLibrary.NanoObj;


public class Thread_ParallelFillUp3 extends Thread{	

	public OctreeRoot root;
	private List<NanoObj> subList=new ArrayList<NanoObj>();	
	private CountDownLatch latch;
	boolean done=false;


	public Thread_ParallelFillUp3(OctreeRoot root, List subList, CountDownLatch latch) {
		this.root=root;
		this.latch=latch;	
		this.subList.addAll(subList);
	}

	public void run() {		
		
		for(NanoObj n:subList){
			n.attachOnNodeTree(root);
		}
		latch.countDown();	
	}	
}
