package Wrappers;


/** This class wrap the useful informations required for the simulation needs. 
 * More in details: cube ID, its coordinates, the actual timestep and the total amount of assimilations of its surface receptors
 * 
 */

public class OutputWrapper {
	
	
	public String id;
	public float[] center;
	public long timestep;
	public int assimilations;
	
	
	public OutputWrapper(String id, float[] center, long timestep, int assimilations){
		this.id = id;
		this.center = center;
		this.timestep = timestep;
		this.assimilations = assimilations;
	}
}