package Wrappers;

import java.util.ArrayList;


public class WrapperBloodCells {

	private ArrayList<WrapperNanoObj> redBloodCellList=new ArrayList<WrapperNanoObj>();
	private ArrayList<WrapperNanoObj> macrophageList=new ArrayList<WrapperNanoObj>();
	private ArrayList<WrapperNanoObj> plateletList=new ArrayList<WrapperNanoObj>();
	
	private static WrapperBloodCells instance=null;
	
	public static WrapperBloodCells getInstance(){
		if (instance==null) instance=new WrapperBloodCells();
		return instance;
	}
	
	private WrapperBloodCells(){
		
	}

	public ArrayList<WrapperNanoObj> getRedBloodCellList() {
		return redBloodCellList;
	}

	public void addRedBloodCells(WrapperNanoObj redBloodCell) {		
			
		this.redBloodCellList.add(redBloodCell);
	}

	public ArrayList<WrapperNanoObj> getMacrophageList() {
		return macrophageList;
	}

	public void addMacrophageList(WrapperNanoObj macrophage) {
		this.macrophageList.add(macrophage);
	}

	public ArrayList<WrapperNanoObj> getPlateletList() {
		return plateletList;
	}

	public void addPlateletList(WrapperNanoObj platelet) {
		this.plateletList.add(platelet);
	}
}
