package MainLibrary;
import java.util.ArrayList;
import java.util.List;

public class CheckNanoObjCollisionThread extends Thread{
	
	private List<NanoObj> objsToCheck=new ArrayList<NanoObj>();
	private MobilityModel model;
	private int start,stop;
	public ArrayList<NanoCollision> list=new ArrayList<NanoCollision>();
	
	public CheckNanoObjCollisionThread(int start,int stop,List<NanoObj> objsToCheck,MobilityModel d){
		this.objsToCheck=objsToCheck;
		this.model=d;
		this.start=start;
		this.stop=stop;
		setDaemon(true);
	}

	public void run(){		
		//Check Collision!!
		boolean isFinish=false;
		for (int i=start;i<=stop;i++){
			isFinish=false;
			for (int j=i+1;j<objsToCheck.size() && !isFinish;j++){
				if(objsToCheck.get(j).getAbsDistancePlusRadius()>=objsToCheck.get(i).getAbsDistanceMinusRadius()){				
					model.detectCollision(objsToCheck.get(j),objsToCheck.get(i));
				} else{
					isFinish=true;
				}
			}
		}		
	}	
}
