package MainLibrary;

import java.util.HashMap;
import java.util.Map;
import com.threed.jpct.SimpleVector;

public class ConfigWrapper {
	
	public Map<String, Float> nodeConfig=new HashMap<String,Float>();
	public Map<String, Float> carrierConfig=new HashMap<String,Float>();
	public Map<String, Float> genericObjConfig=new HashMap<String,Float>();
	public Map<String, Float> receptorStateConfig=new HashMap<String,Float>();
	public Map<String, Float> nodeStateConfig=new HashMap<String,Float>();
	public Map<String, Float> domainStrategyConfig=new HashMap<String,Float>();
	
	public long simulationTimeLength;
	public long exportTimeLength=1000;		

	public int threads=1;

	public float ddt=1;
	public float _dt=1;
	public long timeUnit=1;			
		
	public float T=310;  // temperature Kelvin degree
	public float viscosity=(float) (1.1*Math.pow(10, -3));
	public int u;
	public int nodeTreeLimit=10000;	
	public int nodeSideLimit=10000;	
	public int printTimeOnScreen=1000;
	
	public double ed=1;
	
	// Engine 3D
	public float[] camera=new float[3];
	public SimpleVector lookAt=new SimpleVector();
	public int[] lights=new int[3];
	public int[] window=new int[2];	
	
	public ConfigWrapper(){
		
	}
}
