package MainLibrary;

public class DomainCollisionInternal extends AbstractCollision{

	private NanoObj p;
	private AbstractDomain d;	
	
	public DomainCollisionInternal(NanoObj p, AbstractDomain d, double dt){
		this.p=p;
		this.d=d;
		this.setDt(dt);	
	}	
	
	public void handleCollision(){			
		if(p.getDomain()==d){		
			p.estabilishContact(d);
		}		
	}	
}