package MainLibrary;

import java.util.ArrayList;
import java.util.Iterator;

public class EventHandlerForReceptors {

	public ArrayList<UniversalReceptor> activeReceptorsList=new ArrayList<UniversalReceptor>();
	public ArrayList<UniversalReceptor> toBeInactivatedFromReceptorsList=new ArrayList<UniversalReceptor>();
	
	public EventHandlerForReceptors(){
		
	}	

	public void addActiveReceptor(UniversalReceptor r){
		if (!activeReceptorsList.contains(r)) activeReceptorsList.add(r);
	}
	
	public void removeInactiveReceptor(UniversalReceptor r){		
		if (!toBeInactivatedFromReceptorsList.contains(r)) {
			toBeInactivatedFromReceptorsList.add(r);
		}		
	}
	
	public void trigger(){		
		try {			
			Iterator<UniversalReceptor> it=activeReceptorsList.iterator();
			while(it.hasNext()){
				it.next().trigger();
			}			
		} catch (Exception e) {
			e.printStackTrace();
		}	
		
		toBeInactivatedFromReceptorsList.clear();		
	}
}
