package MainLibrary;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.CountDownLatch;

public class Thread_NextSimulationStep extends Thread{
	
	protected List<AbstractDomain> partialDomainList=new ArrayList<AbstractDomain>();
	protected CountDownLatch latch=null;
	
	public Thread_NextSimulationStep(List<AbstractDomain> domain, CountDownLatch latch){
		partialDomainList=domain;	
		this.latch=latch;		
	}

	public void run(){	
		
		for (int i=0;i<partialDomainList.size();i++){			
			partialDomainList.get(i).nextSimulationStep();			
		}
		
		latch.countDown();
	}	
}



