package MainLibrary;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.CountDownLatch;
import MainLibrary.NanoObj;
import Octree.OctreeRoot;

public class Thread_OctreeFillUp extends Thread{	
	
	public OctreeRoot root;
	private CountDownLatch latch;
	private List<NanoObj> nanoList=new ArrayList<NanoObj>();
	
	public Thread_OctreeFillUp(OctreeRoot root, List<NanoObj> nanoList, CountDownLatch latch) {
		this.root=root;
		this.latch=latch;
		this.nanoList.addAll(nanoList);
	}

	public void run() {		

		root.fillUp(nanoList);		
		latch.countDown();	
	}
}
