package MainLibrary;

public class XORShiftRandom {
	
	private long seed = System.nanoTime();		  

	public XORShiftRandom() {
		
	}

	
	protected int next(int nbits) {
		// FIXME It is not thread-safe!
		long x = this.seed;
		x ^= (x << 21);
		x ^= (x >>> 35);
		x ^= (x << 4);
		this.seed = x;
		x &= ((1L << nbits) -1);
		return  (int)(x);		
	}
}