package MainLibrary;

public class rUploading extends ReceptorState {

	private int type;
	public rUploading(UniversalReceptor r) {
		super(r);
		setFree(false);
		type=r.getReceptorType();
		setProcessingTime(getTiming());	
		r.eventHandler.addActiveReceptor(r);
	}

	public int getTiming(){		
		return getReceptor().getOuterDomain().getManager().configWrapper.receptorStateConfig.get(type+"-uploadTime").intValue();
	}

	public void performAction() {
		if (getReceptor().getCurrentCarrier()!=null){
			if (remainingTime>0){
				remainingTime--;
			}else{			
				getReceptor().upload();					
			}
		}else{
			getReceptor().setInternalState(new rActive(getReceptor()));
		}
	}
}

