package Octree;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.CountDownLatch;
import MainLibrary.NanoObj;


public class Thread_ParallelFillUp extends Thread{	
	
	public OctreeRoot root;
	private CountDownLatch latch;
	private List<NanoObj> subList=new ArrayList<NanoObj>();
	
		
	public Thread_ParallelFillUp(OctreeRoot octreeNode, List<NanoObj> subList, CountDownLatch latch) {
		this.root=octreeNode;
		this.latch=latch;
		this.subList=subList;
	}

	public void run() {		
		
		if(subList.size()>0){
			// fillup root tree
			for(NanoObj n:subList){
				n.attachOnNodeTree(root);		
			}
		}
		latch.countDown();	
	}
}
