package Wrappers;


/** This class wrap the useful informations required for the simulation needs. 
 * More in details: cube ID, its coordinates, the actual timestep and the total amount of assimilations of its surface receptors
 * 
 */

public class OutputWrapperBloodVessel {
	
	public String id;
	public String x,y,z;
	public String timestep;
	public String assimilations;
	public String genericNotes;
	
	
	/*
	public String id;
	public float[] center;
	public long timestep;
	public int assimilations;
	
	
	public OutputWrapper(String id, float[] center, long timestep, int assimilations){
		this.id = id;
		this.center = center;
		this.timestep = timestep;
		this.assimilations = assimilations;
	}
	*/
	
	public OutputWrapperBloodVessel(String id, String x, String y, String z, String timestep, String assimilations, String genericNotes){
		this.id = id;
		this.x = x;
		this.y = y;
		this.z = z;
		this.timestep = timestep;
		this.assimilations = assimilations;	
		this.genericNotes=genericNotes;
	}
	
	public String getExportString(){
		return timestep+" "+id+" "+x+" "+y+" "+z+" "+assimilations+" "+genericNotes;
	}
}
