package simulator;

import java.util.Map;

import MainLibrary.CarrierObj;
import MainLibrary.EventHandlerForReceptors;
import MainLibrary.GenericLigandObserver;
import MainLibrary.LigandObserver;
import MainLibrary.NodeObj;
import MainLibrary.Receptor;

public class CD154Receptor extends Receptor{
	
	public CD154Receptor(NodeObj node, boolean canDownload, float[] center, float theta, float fi, short r, int type, EventHandlerForReceptors e) {
		super(node, canDownload, center, theta, fi, r, type, e);		
	}

	@Override
	public void downloadCarrier(CarrierObj c) {
		node.downloadInfoFrom(c,this);
	}

	@Override
	public Map<Object,Object> export() {
		return null;
	}
	
	@Override
	public LigandObserver getMyObserver() {		
		return GenericLigandObserver.getInstance();
	}
	
	public String assignName(){
		return "CD154Receptor";	
	}
}
